# Convert PdBI Obs. Log
# Modif 07-Apr-2011: pol4 = 4
##################################

BEGIN {
   mon["JAN"] = "01";
   mon["FEB"] = "02";
   mon["MAR"] = "03";
   mon["APR"] = "04";
   mon["MAY"] = "05";
   mon["JUN"] = "06";
   mon["JUL"] = "07";
   mon["AUG"] = "08";
   mon["SEP"] = "09";
   mon["OCT"] = "10";
   mon["NOV"] = "11";
   mon["DEC"] = "12";
}

function set_freq() {
   if ((ifb>0) && (ifc>0)) {	# Use min/max 
       f1 = 0; f3 = 999999999999;
       for (i=1; i<=ifc; i++) {
           freq = fc[i] - 0.475*fb[i]; if (freq<f3) f3 = freq;
           freq = fc[i] + 0.475*fb[i]; if (freq>f1) f1 = freq;
       }
       sb1 = sbu; sb3 = sbu
   }
   else if (fu != "") {	# Addition Apr.2008: single frquency 
        freq = fu*1000;
	if ((freq>200000) && (f1 == "")) { f1 = freq; sb1 = sbu; }
	if ((freq<200000) && (f3 == "")) { f3 = freq; sb3 = sbu; }
    }
}

/^[A-Z][A-Z0-9-]/ {	# Beginning of a New Record
    nx = split($3, ax, "-");
    if (nx != 3) next
    ID = $2; gsub(/_/, " ", ID);
    o++;
    printf "%2d ", NF;
    printf "%-8s %-12s %s-%s-%s ", $1, ID, ax[3],mon[ax[2]], ax[1];
    printf "%5s %5s %6s ", $4, $5, $6;
    T = substr($0,61, 3); 	# Type of observation
    #printf "%6s%1s%6s%1s", $9, $10, $11, $12;
    hline = $0; hword = NF;
    i = NF-4; Ep = $i+0;
    if (Ep<1950) { wEp = $i }
    else { ++i; RA = $i; ++i; DE = $i; }
    AC = substr($8,1,3);
    next
}
/^ *$/{
    if (o < 1) next;
    if (Ep<1950) {
	print "++++Bad Epoch", wEp ", NF=" hword  ", o=", o \
	    ", RA=" RA ", DE=" DE > "/dev/stderr" ;
	print "    Record:", hline > "/dev/stderr" ;
	Ep = "";
    }
    RAt = RA; gsub(/[0.: +-]/, "", RAt);
    DEt = DE; gsub(/[0.: +-]/, "", DEt);
    set_freq();
    if ((RAt == "") && (DEt == "")) { RA = ""; DE = "" }
    if (o>0) {
       printf " %3s %4s %-14s%-14s %6.1f%1s %6d%1s %6d%1s %-2s%-2s %-3s %s\n",\
       T, Ep, RA, DE, V+0, cV, f3, sb3, f1, sb1, pol, pol4, AC, St;
    }
    o=0;
    RA=""; DE=""; AC=""; St=""; T=""; Ep=0;
    f3 = ""; f1 = ""; fu = ""; sb3 = ""; sb1 = ""; sbu = ""; V=""; cV="";
    ifb=0; ifc=0; pol = ""; pol4="";
    next
}

/^ *RA[12][0-9]*: / { Ep=substr($1,3,4); RA=$2; DE=$4; next }
######/^ *RA2000: / { Ep=2000; RA=$2; DE=$4; next }
######/^ *RA1950: / { Ep=1950; RA=$2; DE=$4; next }
/^ *Arrayconf/ { AC=substr($2,1,3); St=$4; next }
/^ *Skyfreq3/  { f3 = $2; sb3 = substr($4,1,1) }
/^ *Skyfreq1/  { f1 = $2; sb1 = substr($4,1,1) }
/^ *Skyfrequency:/ { fu = $2; sbu = substr($4,1,1) }
/^ *SkyCenterofBw.:/  { fc[++ifc] = $2*1000.; fc[++ifc] = $4*1000 }
/^ *Bandwidth.:/      { fb[++ifb] = $2*1.   ; fb[++ifb] = $4*1.   }
/^ *PolarizationBw.:/ { p=$2; if((length(p)==1)&&(index(pol,p)==0)) pol=pol p;
                        p=$4; if((length(p)==1)&&(index(pol,p)==0)) pol=pol p}
/^ *Polar.Cont4GHz:/  { p="H"; if(($2 != "no")&&(index(pol4,p)==0)) pol4=pol4 p;
                        p="V"; if(($4 != "no")&&(index(pol4,p)==0)) pol4=pol4 p}
/^ *Velocity[(]L/  { V = $2; cV = "L" }
/^ *Velocity[(]H/  { V = $2; cV = "H" }
/^ *TypeObserv/    { T = substr($2,1,3); if (index(T,"im")>0) T="" }

END {
    set_freq();
    if (o>0) {
       printf " %3s %4s %-14s%-14s %6.1f%1s %6d%1s %6d%1s %-2s%1s %-3s %s\n",\
       T, Ep, RA, DE, V+0, cV, f3, sb3, f1, sb1, pol, pol4, AC, St;
    }
}
